# Copyright (c) 2000-2008, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

%define gcj_support %{?_with_gcj_support:1}%{!?_with_gcj_support:%{?_without_gcj_support:0}%{!?_without_gcj_support:%{?_gcj_support:%{_gcj_support}}%{!?_gcj_support:0}}}

%define section free

Summary:        JUnit Doclet test generator for JDK 1.4
Name:           junitdoclet-jdk14
Version:        1.0.2
Release:        6%{dist}
Epoch:          0
License:        LGPL
URL:            http://www.junitdoclet.org/
Group:          Development/Test/Java
#Vendor:         JPackage Project
#Distribution:   JPackage
Source0:        JUnitDoclet_1.0.2_jdk1.4.zip
Patch0:         junitdoclet-jdk142.patch
Patch1:         junitdoclet-jdk14-build.patch
Patch2:         junitdoclet-jdk14-DocImpl.patch
Patch3:         junitdoclet-jdk14-ProgramElementDocImpl.patch
Patch4:         junitdoclet-jdk14-ClassDocImpl.patch
Patch5:         junitdoclet-jdk14-MethodDocImpl.patch
Patch6:         junitdoclet-jdk14-PackageDocImpl.patch
Patch7:         junitdoclet-jdk14-ParameterImpl.patch

BuildRequires:  jpackage-utils >= 0:1.7.5
BuildRequires:  ant >= 0:1.6
BuildRequires:  ant-junit >= 0:1.6
BuildRequires:  java-devel = 0:1.5.0
Requires:       java = 0:1.5.0
%if ! %{gcj_support}
BuildArch:      noarch
%endif
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-buildroot
%if %{gcj_support}
BuildRequires:    gnu-crypto
BuildRequires:    java-gcj-compat-devel
Requires(post):   java-gcj-compat
Requires(postun): java-gcj-compat
%endif

%description
Especially creating and maintaining a test structure is 
often used as an excuse. JUnitDoclet lowers the step 
toward JUnit. It generates skeletons of TestCases based 
on your application source code. And it supports you to 
reorganize tests during refactoring. Suddenly all the 
excuses don't count any longer. 

%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation
#Requires(post):   /bin/rm,/bin/ln
#Requires(postun): /bin/rm

%description javadoc
%{summary}.

%package manual
Summary:        Documents and Examples for %{name}
Group:          Development/Documentation

%description manual
%{summary}.

%prep
%setup -T -c -n JUnitDoclet.1.0.2
(cd ..
unzip -q %{SOURCE0}
)
rm JUnitDoclet.jar
rm *.txt
unzip -q src.zip
rm src.zip

%patch0 -b .sav0
%patch1 -b .sav1
%patch2 -b .sav2
%patch3 -b .sav3
%patch4 -b .sav4
%patch5 -b .sav5
%patch6 -b .sav6
%patch7 -b .sav7

%build
export JAVA_HOME=/usr/lib/jvm/java-1.5.0
export OPT_JAR_LIST="ant-launcher ant/ant-junit junit"
export CLASSPATH=
ant -Dbuild.sysclasspath=first

%install
rm -rf $RPM_BUILD_ROOT

# jars
mkdir -p $RPM_BUILD_ROOT%{_javadir}
cp -p build/JUnitDoclet.jar $RPM_BUILD_ROOT%{_javadir}/%{name}-%{version}.jar
(cd $RPM_BUILD_ROOT%{_javadir} && for jar in *-%{version}.jar; do ln -sf ${jar} `echo $jar| sed "s|-%{version}||g"`; done)
mkdir -p $RPM_BUILD_ROOT%{_datadir}/%{name}-%{version}/res
cp -p res/* $RPM_BUILD_ROOT%{_datadir}/%{name}-%{version}/res

# javadoc
mkdir -p $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
cp -pr build/javadoc/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
ln -s %{name}-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name} # ghost symlink

# manual
mkdir -p $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}
cp -pr build/JUnitDoclet.unreleased/doc/* $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}

%if %{gcj_support}
export CLASSPATH=$(build-classpath gnu-crypto)
%{_bindir}/aot-compile-rpm --exclude %{_docdir}/%{name}-%{version}/ide/packagelister.jar
%endif

%clean
rm -rf $RPM_BUILD_ROOT

#%post javadoc
#rm -f %{_javadocdir}/%{name}
#ln -s %{name}-%{version} %{_javadocdir}/%{name}

#%postun javadoc
#if [ "$1" = "0" ]; then
#  rm -f %{_javadocdir}/%{name}
#fi

%if %{gcj_support}
%post
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%if %{gcj_support}
%postun
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%files
%defattr(0644,root,root,0755)
%doc %{_docdir}/%{name}-%{version}/lgpl.txt
%{_javadir}/*.jar
%{_datadir}/%{name}-%{version}
%if %{gcj_support}
%dir %attr(-,root,root) %{_libdir}/gcj/%{name}
%attr(-,root,root) %{_libdir}/gcj/%{name}/%{name}-%{version}.jar.*
%endif

%files javadoc
%defattr(0644,root,root,0755)
%doc %{_javadocdir}/%{name}-%{version}
%ghost %{_javadocdir}/%{name}

%files manual
%defattr(0644,root,root,0755)
%doc %{_docdir}/%{name}-%{version}

%changelog
* Tue Aug 05 2008 Ralph Apel <r.apel at r-apel.de> - 0:1.0.2-6.jpp5
- BR java-devel = 1.5, R java >= 1.5
- Drop javadoc scriptlets
- Patch unit tests

* Tue Feb 27 2007 Ralph Apel <r.apel at r-apel.de> - 0:1.0.2-5jpp
- First JPP-1.7 release
- Add gcj_support option
- Add ant-launcher to OPT_JAR_LIST

* Sun Aug 23 2004 Randy Watler <rwatler at finali.com> - 0:1.0.2-4jpp
- Rebuild with ant-1.6.2

* Fri Aug 06 2004 Ralph Apel <r.apel at r-apel.de> - 0:1.0.2-3jpp
- Void change

* Tue Jun 01 2004 Randy Watler <rwatler at finali.com> - 0:1.0.2-2jpp
- Upgrade to Ant 1.6.X

* Mon Mar 15 2004 Ralph Apel <r.apel at r-apel.de> - 0:1.0.2-1jpp
- First JPackage release
